/*
 * @(#)Object3D.java    Pzt 10 May 2010 14:32:03 EEST
 *
 * 3d Object for 3d world
 */
/*
*** This program wrote under GNU/General Public License ***

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License for more details.
*/
package net.dilmerkezi.object;

import java.awt.Color;

//custom
import net.dilmerkezi.point.*;
import net.dilmerkezi.ray.*;


/**
 * @author Murat iNAN, dilmerkezi.net/eng.html
 */
public interface Object3D
{

    /** 
     * @param r Ray
     * @return If intersects, intersection value
     */
    public double rayIntersect (Ray3D r);

    /**
     * @param p Origin point
     * @return A suitable font size according to p
     */
    public double fontSize (Point3D p);
    
    /**
     * How many ? If you want to prduce 2 coloured
     * objects use 2 etc. If you do not want using this
     * pass it like -1.
     *
     * @return Module count
     */
    public int getModuleCount ();
    
    /**
     * @param p Origin point
     * @return Normalized point
     */
    public Point3D normal (Point3D p);
    
    /**
     * @param p Point of light
     * @param r Used ray
     * @return Reflected 3D ray
     */
    public Ray3D reflect (Point3D p, Ray3D r);
    
    /**
     * @param p Point 3D
     * @return A suitable color value for bg
     */
    public Color background (Point3D p);
    
    /**
     * @param p Point 3D
     * @return A suitable color value for bg
     */
    public Color foreground (Point3D p);
}
/****************/
